﻿using System.Collections.Generic;
using System.Windows.Forms;

namespace FlexPivotEngine
{
    public partial class Form1 : Form
    {
        private DataEngineService svc;
        public Form1()
        {
            InitializeComponent();

            engineView.Visible = false;
            this.svc = new DataEngineService();
            
            var queries = new List<string> { "SalesByCountry", "ProductQuantitySold", "ProductSalesByCountry", "QuantitySoldByPerson", "SalesGroupByYear", "ProductsSoldInYearQuarterly", "FilterESalesByCountry", "FilterNESalesByCountry", "FilteredSalesByCountry" };

            comboBox1.DataSource = queries;
            comboBox1.SelectedIndex = -1;
            comboBox1.SelectedIndexChanged += (s, e) =>
            {
                var item = (s as ComboBox).SelectedItem.ToString();
                this.InvokeMethod(this.svc, item);                              
            };
        }

        public void InvokeMethod(object className, string method)
        {
            var mt = className.GetType().GetMethod(method);
            var list = mt.Invoke(className, new object[] { });
            engineView.DataSource = list;
            engineView.Visible = true;           
        }
    }
}
